/* Measure the energy, magnetization, and square of the magnetization */

#include "comext.h"
#include <stdio.h>

measure(spin)
short spin[IMAX][JMAX];
{
   int bin[MAXQ+1];
   int i,j,n,sumenergy;
   int type, exerr;
   extern int fadd();

   sumenergy = 0; 

   for (n=0;n<Q;n++) bin[n] = 0;  /* initialize Q-state bin */

   for (i=1;i<=isiz;i++) {
   for (j=1;j<=jsiz;j++) {
	 
       	 bin[ spin[i][j] ]++;
 	 sumenergy += (spin[i][j] == spin[i+1][j]) +
	              (spin[i][j] == spin[i][j+1]);
   }}

   type = COMB;
   bin[Q] = sumenergy;
   exerr = excombine(bin,fadd,sizeof(int),Q+1,ALLNODES,NULLPTR,&type);
   sumenergy = bin[Q];

   /* DEBUG */
   if (exerr < 0) {
     fprintf(stderr,"excombine %d\n", exerr);
     fflush(stderr);
     abort(-13);
   }

   /* Energy */
   energy[0] = (double)sumenergy / volume;

   /* Magnetization (spin in the preferred direction) */
   for (n=0;n<Q;n++) Qspin[n] = (double)bin[n] / volume;
   spinmax = Qspin[0];
   maxdir = 0;
   for (i=1;i<Q;i++) {
      if (Qspin[i] > spinmax) {
         spinmax = Qspin[i];
         maxdir = i;
      }
   }  
   mag[0] = ((Q*spinmax) - 1) / (Q-1);

    /* Spin in the 0 direction */
   mag[1] = Qspin[0];

   /* Square of the magnetization */
   magsq[0] = mag[0] * mag[0];

}


int fadd(p1,p2,size)
int *p1,*p2, size;
{
   *p1 += *p2;
   return 0;
}

int floatadd(p1,p2,size)
float *p1,*p2;
int size;
{
   *p1 += *p2;
   return 0;
}

int fmax(p1,p2,size)
int *p1,*p2,size;
{
   if (*p2 > *p1) *p1 = *p2;
   return 0;
}

